
let source = GetCurrentScriptDirectory~"/source/Stage/";

let stbg1 = source~"NonSpellB.png";
let stbg2 = source~"NonSpellA.png";
let stbg3 = source~"stg1bg3.png";
let stgspeed = 3;
let SpellActive = false;

@Initialize{
	SetAutoDeleteObject(true);
	Stage1Bg;
}
@MainLoop{
	yield;
}

task Stage1Bg{
	let StageBG1;
	let StageBGSky;
	let ypos = 0;
	let osize = 0;
	
	
	SetCameraFocusX(0);
	SetCameraFocusY(0);
	SetCameraFocusZ(100);
	SetCameraRadius(300);
	SetCameraElevationAngle(275);
	SetCameraAzimuthAngle(90);		
	
	let vcount = 26;
	StageBG1 = CreateBridgeA1(vcount);
	let bg1size = 256;
	
	StageBGSky = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageBGSky, BLEND_ALPHA);
	ObjRender_SetAlpha(StageBGSky, 255);
	ObjPrim_SetTexture(StageBGSky, NULL);
	ObjSprite3D_SetSourceRect(StageBGSky, 0, 0, 0, 0);
	ObjSprite3D_SetDestRect(StageBGSky, -bg1size*2.5, 0, bg1size*2.5, bg1size*4);
	ObjRender_SetZWrite(StageBGSky, true);
	ObjRender_SetZTest(StageBGSky, true);
	
	ObjRender_SetPosition(StageBGSky, 0, 700, -500);
	ObjRender_SetAngleXYZ(StageBGSky, 90, 0, 0);
	Obj_SetRenderPriority(StageBGSky, 0.72);
		
	SetFogEnable(true);
	SetFogParam(600, 900, 12, 24, 12);
	CreateBrushGroupA1;
	
	while(!GetCommonData("SelectionSet", false)){RenderBG;yield;}
	Obj_SetRenderPriority(StageBG1, 0.22);
	Obj_SetRenderPriority(StageBGSky, 0.21);
	while(GetCommonData("quality", 2)!=0){
		RenderBG;
		yield;
	}
	Obj_Delete(StageBG1);
	Obj_Delete(StageBGSky);
	CloseScript(GetOwnScriptID);
	sub RenderBG{
		SetCameraFocusX(sin(ypos/15)*45); // Remove these two lines
		//SetCameraAzimuthAngle(sin(ypos)*5+90);	// for static camera
		ypos+=stgspeed;
		ascent(i in 0..vcount/2){
			let ivert = i*2;
			let objlen = (256*6/vcount*i);
			ObjPrim_SetVertexUVT(StageBG1, ivert+0, 96+ypos, 512*4/vcount*i);
			ObjPrim_SetVertexUVT(StageBG1, ivert+1, 512+96+ypos, 512*4/vcount*i);
		}
	}
}

function CreateBridgeA1(vcount){
	let obj = ObjPrim_Create(OBJ_PRIMITIVE_3D);
	ObjPrim_SetPrimitiveType(obj, PRIMITIVE_TRIANGLESTRIP);
	let move = 0;
	ObjPrim_SetVertexCount(obj, vcount);
	ObjPrim_SetTexture(obj, stbg1);
	Obj_SetRenderPriority(obj, 0.74);
	ObjRender_SetPosition(obj, 384, 0, 240);
	ObjRender_SetAngleXYZ(obj, -17, 0, 90);
	ObjRender_SetColor(obj, 180, 200, 180);
	let wcount = vcount/2;
	ascent(i in 0..vcount/2){
		let ivert = i*2;
		let objlen = (256*6/vcount*i);
		ObjPrim_SetVertexUVT(obj, ivert+0, 96, 512*4/vcount*i);
		ObjPrim_SetVertexUVT(obj, ivert+1, 512+96, 512*4/vcount*i);
		ObjPrim_SetVertexPosition(obj, ivert+0, 0, objlen, 175-40^(1+absolute(wcount-wcount/2-i)/wcount));
		ObjPrim_SetVertexPosition(obj, ivert+1, 1024, objlen, 175-40^(1+absolute(wcount-wcount/2-i)/wcount));
	}
	return obj;
}


task CreateBrushGroupA1{
	loop{
		CreateJealousyA1;
		loop(16){yield};
	}
}
task CreateBrushGroupA2{
	loop{
		//CreateRainA1;
		loop(9){yield};
	}
}

task CreateLeafA1{
	let leaf = Create3DBrush(255, 32, 0, stbg3, 0.23);
	ObjSprite3D_SetDestRect(leaf, -16, -16, 16, 16);
	let locpos = [rand(-450, 450), rand(300,700), rand(128, 208)];
	let locang = [rand(0,360), rand(0,360), rand(0,360)];
	let locasp = [rand(-3, 3), rand(-3, 3), rand(-3, 3)];
	let alpha = 0;
	let etime = 140;
	locpos[0] = locpos[0]-32;
	ObjRender_SetPosition(leaf, locpos[0], locpos[1], locpos[2]);
	ObjRender_SetAngleXYZ(leaf, locang[0], locang[1], locang[2]);
	ObjRender_SetScaleXYZ(leaf, 0.5, 0.5, 0.5);
	ObjRender_SetColor(leaf, 164, 164, 196);
	Obj_SetRenderPriority(leaf, 0.22);
	if(!GetCommonData("SelectionSet", false)){Obj_SetRenderPriority(leaf, 0.72);}
	
	while(etime > 0){
		etime--;
		alpha = min(alpha + 2, 128);
		UpdatePosition;
		yield;
	}
	while(alpha > 0){
		alpha = max(alpha - 2.5, 0);
		UpdatePosition;
		yield;
	}
	Obj_Delete(leaf);
	sub UpdatePosition{
		locpos[0]=locpos[0]-stgspeed/4;
		locpos[1]=locpos[1]-stgspeed/2;
		locpos[2]=locpos[2]-stgspeed/5;
		locang[0]=locang[0]+locasp[0];
		locang[1]=locang[1]+locasp[1];
		locang[2]=locang[2]+locasp[2];
		ObjRender_SetPosition(leaf, locpos[0], locpos[1], locpos[2]);
		ObjRender_SetAngleXYZ(leaf, locang[0], locang[1], locang[2]);
		ObjRender_SetAlpha(leaf, alpha);
	}
}


task CreateJealousyA1{
	let leaf = Create3DBrush(0, 256, 0, stbg2, 0.22);
	ObjRender_SetBlendType(leaf, BLEND_ADD_ARGB);
	ObjSprite3D_SetDestRect(leaf, -128, -128, 128, 128); // Centered middle origin maybe
	
	let locpos = [rand(-450, 450), rand(-50,300), rand(32, 256), rand(0, 270)];
	let locpin = [rand(-0.75, 0.75), rand(-0.75, 0.75), rand(-0.4, 0.4)];
	let alpha = 0;
	let etime = rand(140, 300);
	let iscl = rand(0.2, 0.6);
	locpos[0] = locpos[0]-32;
	ObjRender_SetPosition(leaf, locpos[0], locpos[1], locpos[2]);
	ObjRender_SetAngleXYZ(leaf, 90, 0, locpos[3]);
	ObjRender_SetScaleXYZ(leaf, iscl, iscl, iscl);
	ObjRender_SetColor(leaf, 164, 164, 196);
	Obj_SetRenderPriority(leaf, 0.22);
	if(!GetCommonData("SelectionSet", false)){Obj_SetRenderPriority(leaf, 0.72);}
	
	while(etime > 0 && locpos[1] > 200*iscl && locpos[1] < 500){
		etime--;
		alpha = min(alpha + 1, 48);
		UpdatePosition;
		yield;
	}
	while(alpha > 0){
		alpha = max(alpha - 1.5, 0);
		let scl = (alpha/48*(iscl/3))+iscl/3*2;
		ObjRender_SetScaleXYZ(leaf, scl, scl, 1);
		UpdatePosition;
		yield;
	}
	Obj_Delete(leaf);
	sub UpdatePosition{
		locpos[0]=locpos[0]+locpin[0];
		locpos[1]=locpos[1]-locpin[1];
		locpos[2]=locpos[2]-stgspeed/5;
		locpos[3]=locpos[3]+locpin[2];
		ObjRender_SetPosition(leaf, locpos[0], locpos[1], locpos[2]);
		ObjRender_SetAlpha(leaf, alpha);
		ObjRender_SetAngleZ(leaf, locpos[3]);
	}
}



function Create3DBrush(alpha, srcrect, offset, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0+offset, 0+offset, srcrect+offset, srcrect+offset);
	ObjSprite3D_SetDestRect(StageProp, 0, -srcrect/2, srcrect, srcrect/2); // Centered middle origin maybe
	//ObjRender_SetZWrite(StageProp, true);
	//ObjRender_SetZTest(StageProp, true);
	return StageProp;
}
function Create3DProperties(alpha, srcrect, image, priority){
	let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
	ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
	ObjRender_SetAlpha(StageProp, alpha);
	ObjPrim_SetTexture(StageProp, image);
	Obj_SetRenderPriority(StageProp, priority);
	ObjSprite3D_SetSourceRect(StageProp, 0, 0, srcrect, srcrect);
	ObjSprite3D_SetDestRect(StageProp, -srcrect, -srcrect, srcrect, srcrect);
	ObjRender_SetZWrite(StageProp, true);
	ObjRender_SetZTest(StageProp, true);
	return StageProp;
}



task CameraFlight{
	// Static Version
	let pos = [0,0,100];
	let ang = [90,295,300];
	let cammod = 1.25;
	loop{
		if(GetKeyState(KEY_J)==KEY_HOLD){pos[0]=pos[0]+5*cammod;}
		if(GetKeyState(KEY_L)==KEY_HOLD){pos[0]=pos[0]-5*cammod;}
		if(GetKeyState(KEY_I)==KEY_HOLD){pos[1]=pos[1]+5*cammod;}
		if(GetKeyState(KEY_K)==KEY_HOLD){pos[1]=pos[1]-5*cammod;}
		if(GetKeyState(KEY_U)==KEY_HOLD){pos[2]=pos[2]-5*cammod;}
		if(GetKeyState(KEY_O)==KEY_HOLD){pos[2]=pos[2]+5*cammod;}
		
		
		if(GetKeyState(KEY_Q)==KEY_HOLD){ang[0]=ang[0]+2*cammod;}
		if(GetKeyState(KEY_E)==KEY_HOLD){ang[0]=ang[0]-2*cammod;}
		if(GetKeyState(KEY_W)==KEY_HOLD){ang[1]=ang[1]+2*cammod;}
		if(GetKeyState(KEY_S)==KEY_HOLD){ang[1]=ang[1]-2*cammod;}
		if(GetKeyState(KEY_A)==KEY_HOLD){ang[2]=ang[2]+2*cammod;}
		if(GetKeyState(KEY_D)==KEY_HOLD){ang[2]=ang[2]-2*cammod;}
		
		SetCameraFocusX(pos[0]);
		SetCameraFocusY(pos[1]);
		SetCameraFocusZ(pos[2]);
		SetCameraAzimuthAngle(ang[0]);	
		SetCameraElevationAngle(ang[1]);
		SetCameraRadius(ang[2]);
		yield;
	}
}


