
let current = GetCurrentScriptDirectory;
let spbg1 = current~"SpellA.png";
let spbg2 = current~"SpellB.png";

@Initialize{
	SpellBG;
}
@MainLoop{
	yield;
}


task SpellBG{
	let fade = 0;
	let spin = 0;
	
	let cdbg1a = CreateBackgroundImageA1(spbg1, 256, 0.23, 2.5);
	let cdbg2a = CreateBackgroundImageA1(spbg2, 256, 0.23, 2.5);
	
	ObjRender_SetPosition(cdbg1a, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
	ObjRender_SetPosition(cdbg2a, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
	yield;
	while(!IsCloseScript(GetScriptArgument("PluralID"))){
		let a = GetEnemyBossSceneObjectID;
		if(a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL)){
			fade = min(fade+12.75, 255);
		}else{fade=0;}
		
		spin+=0.4;
		ObjRender_SetAlpha(cdbg1a, fade);
		ObjRender_SetAlpha(cdbg2a, fade/2);
		ObjRender_SetAngleZ(cdbg1a, spin);
		ObjRender_SetAngleZ(cdbg2a, -spin);
		yield;
	}
	
	Obj_Delete(cdbg1a);
	Obj_Delete(cdbg2a);
	CloseScript(GetOwnScriptID);
}

function CreateBackgroundImageA1(image, rect, pri, scale){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestCenter(BG2PropObj);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}
function CreateBackgroundImageB1(image, rect, pri, scale, left, top, right, bottom){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestRect(BG2PropObj, left, top, right, bottom);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}



